package billing.existing;

import junit.framework.TestCase;

import java.math.BigDecimal;

/**
 * Tests the <code>UsageCalculator</code>.
 */
public class TestUsageCalculator extends TestCase
{
   private static final BigDecimal CONSUMPTION = new BigDecimal(100);
   private static final BigDecimal RATE = new BigDecimal(0.50);

   public void testUsage()
   {
      UsageCalculator usageCalculator = new UsageCalculator();
      BillingContext context = new BillingContext(CONSUMPTION, RATE);

      // 100 * 0.5 = 50
      assertEquals("Charge not as expected", 50, usageCalculator.calculate(context).intValue());
   }
}
