package billing.existing;

import java.math.BigDecimal;

/**
 * The implementation of the <code>UsageCalculator</code>.
 * Usage is defined as $ per MB * consumption in MB.
 */
public class UsageCalculator implements Calculator
{
   public BigDecimal calculate(BillingContext context)
   {
      return context.getRatePerMB().multiply(context.getConsumptionInMB());
   }
}
