package billing.option1;

import billing.existing.BillingContext;
import junit.framework.TestCase;

import java.math.BigDecimal;

/**
 * As the <code>UsageCalculator</code> changes the <code>TestUsageCalculator</code>
 * unit test must change as well.
 */
public class TestUsageCalculator extends TestCase
{
   private static final BigDecimal CONSUMPTION = new BigDecimal(100);
   private static final BigDecimal RATE = new BigDecimal(0.50);
   private static final BigDecimal TAX = new BigDecimal(0.10);

   public void testUsage()
   {
      UsageCalculator usageCalculator = new UsageCalculator(TAX);
      BillingContext context = new BillingContext(CONSUMPTION, RATE);

      // 100 * 0.5 * 1.1 = 55, must change the expected result to cater for the tax
      assertEquals("Charge not as expected", 55, usageCalculator.calculate(context).intValue());
   }
}

