package billing.option1;

import billing.existing.BillingContext;
import billing.existing.Calculator;

import java.math.BigDecimal;

/**
 * Directly modifying the <code>UsageCalculator</code> class.
 */
public class UsageCalculator implements Calculator
{
   private BigDecimal tax;

   public UsageCalculator(BigDecimal tax)
   {
      this.tax = tax;
   }

   public BigDecimal calculate(BillingContext context)
   {
      BigDecimal charge = context.getRatePerMB().multiply(context.getConsumptionInMB());
      // changing the UsageCalculator to cater for the tax
      return charge.add(charge.multiply(tax));
   }
}
