package billing.option2;

import billing.existing.BillingContext;
import billing.existing.UsageCalculator;

import java.math.BigDecimal;

/**
 * Subclass the original <code>UsageCalculator</code> to add the tax.
 */
public class TaxUsageCalculator extends UsageCalculator
{
   private BigDecimal tax;

   public TaxUsageCalculator(BigDecimal tax)
   {
      this.tax = tax;
   }

   public BigDecimal calculate(BillingContext context)
   {
      BigDecimal originalCharge = super.calculate(context);
      return originalCharge.add(originalCharge.multiply(tax));
   }
}
