package billing.option2;

import billing.existing.BillingContext;
import junit.framework.TestCase;

import java.math.BigDecimal;

/**
 * Create a test specifically for the <code>TaxUsageCalculator</code>.
 */
public class TestTaxUsageCalculator extends TestCase
{
   private static final BigDecimal CONSUMPTION = new BigDecimal(100);
   private static final BigDecimal RATE = new BigDecimal(0.50);
   private static final BigDecimal TAX = new BigDecimal(0.10);

   public void testTaxUsage()
   {
      TaxUsageCalculator taxUsageCalculator = new TaxUsageCalculator(TAX);
      BillingContext context = new BillingContext(CONSUMPTION, RATE);

      // 100 * 0.5 * 1.1 = 55
      // this test is still dependent on the UsageCalculator so changes in that class will
      // result in changes to this unit test.
      assertEquals("Charge not as expected", 55, taxUsageCalculator.calculate(context).intValue());
   }
}

