package billing.option3;

import billing.existing.BillingContext;
import billing.existing.Calculator;

import java.math.BigDecimal;

/**
 * Decorates a <code>Calculator</code>
 */
public class TaxCalculator implements Calculator
{
   private Calculator baseCalculator;
   private BigDecimal tax;

   public TaxCalculator(Calculator baseCalculator, BigDecimal tax)
   {
      this.baseCalculator = baseCalculator;
      this.tax = tax;
   }

   public BigDecimal calculate(BillingContext context)
   {
      BigDecimal originalCharge = baseCalculator.calculate(context);
      return originalCharge.add(originalCharge.multiply(tax));
   }
}
